/*
 * Copyright (c) 1998-99 Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <windows.h>

/*
 * SetupConsole
 *     Make sure there is a console to print messages to
 *
 */

void SetupConsole()
{
    static int init_console = 1;
	int hCrt;
	FILE *hf;

    if (init_console) {
        AllocConsole();
        init_console = 0;
    }

	// Setup stdout
	hCrt = _open_osfhandle( (long)GetStdHandle(STD_OUTPUT_HANDLE), _O_TEXT );
	hf = _fdopen(hCrt, "r+" );
	*stdout = *hf;
	*stderr = *hf;
	setvbuf(stdout, NULL, _IONBF, 0);

	// Setup stdin
	hCrt = _open_osfhandle( (long)GetStdHandle(STD_INPUT_HANDLE), _O_TEXT );
	hf = _fdopen(hCrt, "r+" );
	*stdin = *hf;
	setvbuf(stdin, NULL, _IONBF, 0);
}
