/*
 * Copyright (c) 1998-99 Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include <stdio.h>
#include <windows.h>
#include <dmimage.h>
#include "handy.h"
#include "filepacking.h"

__declspec(dllexport)
int DMFormatToFilePacking(int dmformat)
{
	int packing;

	switch (dmformat) {

	case DM_FORMAT_CbYCrY_8_601:
		packing = VL_PACKING_YVYU_422_8;
		break;
	case DM_FORMAT_CbYCrY_10L_601: 
		packing = VL_PACKING_YVYU_422_10;
		break;
	case DM_FORMAT_RGBA_8_FULL:
		packing = VL_PACKING_ABGR_8;
		break;
	default:
		ERR(1, "Unsupported DM format");
		break;
    }
    return packing;
}

__declspec(dllexport)
int FilePackingToDMFormat(int packing)
{
	int format;

	switch (packing) {

	case VL_PACKING_YVYU_422_8:
		format = DM_FORMAT_CbYCrY_8_601;
		break;
	case VL_PACKING_YVYU_422_10: 
		format = DM_FORMAT_CbYCrY_10L_601; 
		break;
	case VL_PACKING_ABGR_8:
		format = DM_FORMAT_RGBA_8_FULL;
		break;
	default:
		ERR(1, "Unsupported file packing");
		break;
    }
    return format;
}
