/*
 * Copyright (c) 1991-1998 Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include "gfxmgr.h"

#include "stdafx.h"

#include <gl/gl.h>
#include <gl/glu.h>

void
gfxmgr::clear()
{
  glClear( GL_COLOR_BUFFER_BIT | GL_COLOR_BUFFER_BIT );
}

void
gfxmgr::draw()
{  
  glMatrixMode( GL_MODELVIEW );

    const float cc = 5.0;
    const float zz = -50;

    glBegin( GL_QUADS );

    glNormal3f( 0, 0, 1 );
    glVertex3f( -cc, -cc, zz + _pp ); 
    glVertex3f( cc, -cc, zz + _pp );  
    glVertex3f( cc, cc, zz + _pp ); 
    glVertex3f( -cc, cc, zz + _pp ); 

    glEnd();
}

void
gfxmgr::init( int ww, int hh )
{
  _pp = -10;

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();

  gluPerspective( 45.0, float(ww)/float(hh), 1.0, 1000.0 );
  glViewport( 0, 0, ww, hh );
  
  glClearColor( 0.2, 0.0, 0.2, 0.0 );
  glEnable( GL_LIGHT0 );
  glEnable( GL_LIGHTING );
  //  glLightModeli( GL_LIGHT_MODEL_TWO_SIDE, 1 );
  
  //  glClearDepth( 1.0 );
  //  glEnable( GL_DEPTH_TEST );
  
  glDrawBuffer( GL_BACK );
  glShadeModel( GL_FLAT );
  
  //  glEnable( GL_CULL_FACE );
}

void
gfxmgr::resize( int ww, int hh )
{
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 45.0, float(ww)/float(hh), 1.0, 100.0 );
  glViewport( 0, 0, ww, hh );
}
