#ifndef __TRACKBALL_OBJ__
#define __TRACKBALL_OBJ__

class csRotation;
class csTransform;

class trackball
{
 public:
  trackball( csTransform *spin, csTransform *ref );
  ~trackball();

  inline void setTrackballTransform( csTransform *xf ) { _spin = xf; }
  inline void setReferenceTransform( csTransform *xf ) { _ref  = xf; }

  inline csTransform * getTrackballTransform() { return( _spin ); }
  inline csTransform * getReferenceTransform() { return( _ref ); }

  // Expects coordinates according to standard Xwindows coordinate
  // systems. Upper-left corner of window is 0,0, lower-right is
  // width,height. dx,dy are mouse movement offets within that
  // coordinate system.

  bool updateTrackball( int xx, int yy, int dx, int dy, int ww, int hh );
  
 private:
  csTransform *_spin;
  csTransform *_ref;

};

#endif // __TRACKBALL_OBJ__
