// MFCViewerView.h : interface of the CMFCViewerView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MFCVIEWERVIEW_H__C49BDF8C_C726_11D2_8F09_0800690CD399__INCLUDED_)
#define AFX_MFCVIEWERVIEW_H__C49BDF8C_C726_11D2_8F09_0800690CD399__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <Cosmo3D\csContext.h>
#include <Cosmo3D\csGroup.h>
#include <Cosmo3D\csPerspCamera.h>
#include <Cosmo3D\csDirectionalLight.h>
#include <Cosmo3D\csDrawAction.h>
#include <Cosmo3D\csField.h>
#include <Cosmo3D\csEnvironment.h>
#include <Optimizer\opDrawAction.h>
#include "trackball.h"

class CMFCViewerView : public CView
{
protected: // create from serialization only
	CMFCViewerView();
	DECLARE_DYNCREATE(CMFCViewerView)

// Attributes
public:
	CMFCViewerDoc* GetDocument();

// Operations
public:
	HDC m_hDC;
	csContext *theContext;
#ifdef OPDRAW
	opDrawAction *theDraw;
#else
	csDrawAction *theDraw;
#endif

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMFCViewerView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	void NewScene(void);
	void paint(void);
	void resizeToFit(csGroup *node);
	void setClipPlanes(void);
	enum {NO_REFRESH, REFRESH, MVT_REFRESH};
	int _mousex;
	int _mousey;
	int  need_refresh;
    float _startz;
    int _zoom;
    float _startx;
    int _transx;
    float _starty;
    int _transy;
	int height;
	int width;
	csLight** theLightArray;
	trackball *theBall;
	csPerspCamera *theCam;
	csTransform *thePose;
	csGroup *theUserRoot;
	csEnvironment theRoot;
	void InitializeScene(void);
	void OnPaletteChanged(CWnd *pFocusWnd);
	int OnQueryNewPalette(void);
	void InitializePalette(void);
	CPalette m_GLPalette;

	virtual ~CMFCViewerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMFCViewerView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MFCViewerView.cpp
inline CMFCViewerDoc* CMFCViewerView::GetDocument()
   { return (CMFCViewerDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MFCVIEWERVIEW_H__C49BDF8C_C726_11D2_8F09_0800690CD399__INCLUDED_)
