// MultiOGLView.h : interface of the CMultiOGLView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MULTIOGLVIEW_H__5A99F6AF_4353_11D2_866A_08003629EA02__INCLUDED_)
#define AFX_MULTIOGLVIEW_H__5A99F6AF_4353_11D2_866A_08003629EA02__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

struct COGLRenderThreadInfo {
	HGLRC m_hRC;
	HDC m_hDC;
	HWND m_hWnd;
	HANDLE m_hEventOGLRenderThreadKilled;	
	HANDLE m_hEventOGLRenderThreadKill;
	HANDLE m_hEventOGLRenderSetHighlight;
	HANDLE m_hEventOGLRenderKillHighlight;
	HANDLE m_hEventOGLRenderOnSize;
	int height;
	int width;
};

UINT OGLRenderThreadProc(LPVOID pParam /* COGLRenderThreadInfo ptr */);
  
class CMultiOGLView : public CView
{
protected: // create from serialization only
	CMultiOGLView();
	DECLARE_DYNCREATE(CMultiOGLView)

// Attributes
public:
	CMultiOGLDoc* GetDocument();

	CWinThread * m_pOGLRenderThread;
	COGLRenderThreadInfo m_OGLRenderThreadInfo;
	HANDLE m_hEventOGLRenderThreadKilled;	
	HANDLE m_hEventOGLRenderThreadKill;
	HANDLE m_hEventOGLRenderSetHighlight;
	HANDLE m_hEventOGLRenderKillHighlight;
	HANDLE m_hEventOGLRenderOnSize;
	int height;
	int width;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMultiOGLView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMultiOGLView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	HGLRC m_hRC;
	HDC m_hDC;

	//{{AFX_MSG(CMultiOGLView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MultiOGLView.cpp
inline CMultiOGLDoc* CMultiOGLView::GetDocument()
   { return (CMultiOGLDoc*)m_pDocument; }
#endif


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MULTIOGLVIEW_H__5A99F6AF_4353_11D2_866A_08003629EA02__INCLUDED_)
