/*
 * Copyright 1999 Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED
 *
 * You may use and modify this software and its documentation for your own
 * internal purposes without fee, provided that you agree that you will not
 * remove this notice from this software under any circumstances.  You may not
 * disclose the contents of this file to third parties in any form, in whole
 * or in part, without the prior written permission of Silicon Graphics, Inc.
 *
 * THIS SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT ANY WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
 * OF MERCHANTABLIITY OR FITNESS FOR A PARTICULAR PURPOSE.
 * In no event shall Silicon Graphics be liable for any special, incidental,
 * indirect or consequential damages of any kind, or any damages whatsoever
 * resulting from loss of use, data or profits, whether or not advised of the
 * possibility of damage, and on any theory of liability, arising out of or
 * in connection with the possession, use or performance of this software.
 *
 * U.S. GOVERNMENT RESTRICTED RIGHTS LEGEND
 * Use, duplication, or disclosure by the Government is subject to restrictions
 * set forth in FAR 52.227.19(c)(2) or subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013 and/or in
 * similar or successor clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the United States.
 * Contractor/manufacturer is Silicon Graphics, Inc., 2011 N. Shoreline Blvd.,
 * Mountain View, CA 94039-7311.
 *
 * Author: Jacques Lefaucheux   jacques@paris.sgi.com
 * January 20, 1999
 */


#ifndef _OVERLAYS_CLASS_JLX
#define _OVERLAYS_CLASS_JLX
#include <windows.h>	// Win32
#include <GL/gl.h>		// OpenGL header file
#include <GL/glu.h>		// OpenGL utilities


#define TRANSPARENT_PIXEL 0
#define RED 1
#define GREEN 2
#define BLUE 3
#define MAGENTA 4
#define YELLOW 5
#define CYAN 6
#define WHITE 7
#define BLACK 8
#define MAX_OVERLAY_COLORS 9

#define OVL_SINGLE     1
#define OVL_DOUBLE     2
#define OVL_RGBA       4
#define OVL_COLORINDEX 8

// for debug 
// DEBUG_OVL is defined in the VC++ project 
// Project->Settings->Win32Debug->C/C++ 
// under Preprocessor definitions box

// prototypes
#ifdef  __cplusplus
extern "C" {
#endif

#ifdef DEBUG_OVL
void dumpOverlays(HDC hDC,int i,int n);
void dumpNormals(HDC hDC,int i);
#endif

int  createContextAndOverlays(HDC hDC,HGLRC *ctx,HGLRC *ovlctx,DWORD flags);

#ifdef  __cplusplus
 }
#endif


#endif