// simpleMFCView.cpp : implementation of the CSimpleMFCView class
//

#include "stdafx.h"
#include "simpleMFC.h"

#include "simpleMFCDoc.h"
#include "simpleMFCView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSimpleMFCView

IMPLEMENT_DYNCREATE(CSimpleMFCView, CView)

BEGIN_MESSAGE_MAP(CSimpleMFCView, CView)
	//{{AFX_MSG_MAP(CSimpleMFCView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimpleMFCView construction/destruction

CSimpleMFCView::CSimpleMFCView()
{
	// TODO: add construction code here

}

CSimpleMFCView::~CSimpleMFCView()
{
}

BOOL CSimpleMFCView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS | CS_OWNDC);

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSimpleMFCView drawing

void CSimpleMFCView::OnDraw(CDC* pDC)
{
	CSimpleMFCDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	wglMakeCurrent(m_hDC, m_hRC);
	
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	
	glMatrixMode( GL_MODELVIEW );
	
	glPushMatrix();
	glTranslatef( 0.0, 0.0, -250.0 );
	
	glColor4f( 1.0, 0.0, 0.0, 1.0 );
	glBegin( GL_QUADS );
	glVertex2f( -20.0f, -20.0f );
	glVertex2f( -20.0f,  20.0f );
	glVertex2f( 20.0f, 20.0f );
	glVertex2f( 20.0f, -20.0f );
	glEnd();
	
	glPopMatrix();
	
	if ( doubleBuffered )
		SwapBuffers(m_hDC);
	else
		glFlush();
	
	wglMakeCurrent( NULL, NULL );
	
	ValidateRect(NULL);
}

/////////////////////////////////////////////////////////////////////////////
// CSimpleMFCView diagnostics

#ifdef _DEBUG
void CSimpleMFCView::AssertValid() const
{
	CView::AssertValid();
}

void CSimpleMFCView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSimpleMFCDoc* CSimpleMFCView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSimpleMFCDoc)));
	return (CSimpleMFCDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSimpleMFCView message handlers

int CSimpleMFCView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	
	PIXELFORMATDESCRIPTOR   pfd;
	int     pixelFormat;
	
	m_hDC = ::GetDC(m_hWnd);
	
	pfd.nSize =             sizeof(PIXELFORMATDESCRIPTOR);
	pfd.nVersion =          1;
	pfd.dwFlags =           PFD_DRAW_TO_WINDOW |
		                    PFD_SUPPORT_OPENGL |
		                    PFD_DOUBLEBUFFER;
	pfd.iPixelType =        PFD_TYPE_RGBA;
	pfd.cColorBits =        24;
	pfd.cRedBits =          0;
	pfd.cRedShift =         0;
	pfd.cGreenBits =        0;
	pfd.cGreenShift =       0;
	pfd.cBlueBits =         0;
	pfd.cBlueShift =        0;
	pfd.cAlphaBits =        0;
	pfd.cAlphaShift =       0;
	pfd.cAccumBits =        0;
	pfd.cAccumRedBits =     0;
	pfd.cAccumGreenBits =   0;
	pfd.cAccumBlueBits =    0;
	pfd.cAccumAlphaBits =   0;
	pfd.cDepthBits =        0;
	pfd.cStencilBits =      0;
	pfd.cAuxBuffers =       0;
	pfd.iLayerType =        PFD_MAIN_PLANE;
	pfd.bReserved =         0;
	pfd.dwLayerMask =       0;
	pfd.dwVisibleMask =     0;
	pfd.dwDamageMask =      0;
	
	
	pixelFormat = ChoosePixelFormat(m_hDC, &pfd);
	
	DescribePixelFormat(m_hDC, pixelFormat,
		sizeof(PIXELFORMATDESCRIPTOR),
		&pfd);
	
	if ( pfd.dwFlags & PFD_NEED_PALETTE ||
		pfd.iPixelType == PFD_TYPE_COLORINDEX )
		BuildPalette( &pfd );
	
	if ( pfd.dwFlags & PFD_DOUBLEBUFFER )
		doubleBuffered = TRUE;
	else
		doubleBuffered = FALSE;

	if(SetPixelFormat(m_hDC, pixelFormat, &pfd) == FALSE)
		exit(1);
	
	m_hRC = wglCreateContext(m_hDC);

	wglMakeCurrent( m_hDC, m_hRC );
	
	SetupScene();

	wglMakeCurrent( NULL, NULL );

	return 0;
}

void CSimpleMFCView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	wglMakeCurrent( m_hDC, m_hRC );
	glViewport( 0, 0, cx, cy );

	wglMakeCurrent( NULL, NULL );
	InvalidateRect( NULL );
}

BOOL CSimpleMFCView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	
	return 1;
}

void CSimpleMFCView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
	wglMakeCurrent( NULL, NULL );
	wglDeleteContext( m_hRC );
	::ReleaseDC( m_hWnd, m_hDC );

}

void CSimpleMFCView::BuildPalette(PIXELFORMATDESCRIPTOR * pfd)
{
	LOGPALETTE *pal;
	int i, paletteSize, redMask, greenMask, blueMask;
	
	paletteSize = 1 << pfd->cColorBits;
	
	pal = (LOGPALETTE *)
		malloc(sizeof(LOGPALETTE) + paletteSize * sizeof(PALETTEENTRY));
	pal->palVersion = 0x300;
	pal->palNumEntries = paletteSize;
	
	redMask = (1 << pfd->cRedBits) - 1;
	greenMask = (1 << pfd->cGreenBits) - 1;
	blueMask = (1 << pfd->cBlueBits) - 1;
	
	for (i = 0; i < paletteSize; i++)
    {
		pal->palPalEntry[i].peRed = ((i >> pfd->cRedShift) & redMask);
		pal->palPalEntry[i].peRed = (unsigned char)
			((double) pal->palPalEntry[i].peRed * 255.0 / redMask);
		pal->palPalEntry[i].peGreen = ((i >> pfd->cGreenShift) & greenMask);
		pal->palPalEntry[i].peGreen = (unsigned char)
			((double) pal->palPalEntry[i].peGreen * 255.0 / greenMask);
		pal->palPalEntry[i].peBlue = ((i >> pfd->cBlueShift) & blueMask);
		pal->palPalEntry[i].peBlue = (unsigned char)
			((double) pal->palPalEntry[i].peBlue * 255.0 / blueMask);
		pal->palPalEntry[i].peFlags = 0;
    }
	
	m_palette = CreatePalette(pal);
	free(pal);
	
	if (m_palette)
    {
		SelectPalette(m_hDC, m_palette, FALSE);
		RealizePalette(m_hDC);
    }

}

void CSimpleMFCView::SetupScene()
{
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	gluPerspective( 75.0, 1.0, 0.3, 400.0 );
	
	glClearColor( 0.0, 0.0, 0.0, 1.0 );
}
